| OpenCV 3.4.1 Open Source Computer Vision

Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::xfeatures2d::BoostDesc Class Referenceabstract
Extra 2D Features Framework » Experimental 2D Features Algorithms

Class implementing BoostDesc (Learning Image Descriptors with Boosting), described in [172] and [173]. More...

`#include "xfeatures2d.hpp"`

Inheritance diagram for cv::xfeatures2d::BoostDesc:

## Public Types
enum | { BGM = 100, BGM_HARD = 101, BGM_BILINEAR = 102, LBGM = 200, BINBOOST_64 = 300, BINBOOST_128 = 301, BINBOOST_256 = 302 }

## Public Member Functions
virtual float | getScaleFactor () const =0
virtual bool | getUseScaleOrientation () const =0
virtual void | setScaleFactor (const float scale_factor)=0
virtual void | setUseScaleOrientation (const bool use_scale_orientation)=0
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant). More...
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant). More...
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
virtual bool | empty () const
| Return true if detector object is empty. More...
virtual String | getDefaultName () const
void | read (const String &fileName)
virtual void | read (const FileNode &)
| Reads algorithm parameters from a file storage. More...
void | write (const String &fileName) const
virtual void | write (FileStorage &) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual void | save (const String &filename) const
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< BoostDesc > | create (int desc=BoostDesc::BINBOOST_256, bool use_scale_orientation=true, float scale_factor=6.25f)
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing BoostDesc (Learning Image Descriptors with Boosting), described in [172] and [173].

Parameters

  desc | type of descriptor to use, BoostDesc::BINBOOST_256 is default (256 bit long dimension) Available types are: BoostDesc::BGM, BoostDesc::BGM_HARD, BoostDesc::BGM_BILINEAR, BoostDesc::LBGM, BoostDesc::BINBOOST_64, BoostDesc::BINBOOST_128, BoostDesc::BINBOOST_256
  use_orientation | sample patterns using keypoints orientation, enabled by default
  scale_factor | adjust the sampling window of detected keypoints 6.25f is default and fits for KAZE, SURF detected keypoints window ratio 6.75f should be the scale for SIFT detected keypoints window ratio 5.00f should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints window ratio 0.75f should be the scale for ORB keypoints ratio 1.50f was the default in original implementation

Note
  BGM is the base descriptor where each binary dimension is computed as the output of a single weak learner. BGM_HARD and BGM_BILINEAR refers to same BGM but use different type of gradient binning. In the BGM_HARD that use ASSIGN_HARD binning type the gradient is assigned to the nearest orientation bin. In the BGM_BILINEAR that use ASSIGN_BILINEAR binning type the gradient is assigned to the two neighbouring bins. In the BGM and all other modes that use ASSIGN_SOFT binning type the gradient is assigned to 8 nearest bins according to the cosine value between the gradient angle and the bin center. LBGM (alias FP-Boost) is the floating point extension where each dimension is computed as a linear combination of the weak learner responses. BINBOOST and subvariants are the binary extensions of LBGM where each bit is computed as a thresholded linear combination of a set of weak learners. BoostDesc header files (boostdesc_*.i) was exported from original binaries with export-boostdesc.py script from samples subfolder.

## Member Enumeration Documentation

## § anonymous enum

anonymous enum

Enumerator
BGM |
BGM_HARD |
BGM_BILINEAR |
LBGM |
BINBOOST_64 |
BINBOOST_128 |
BINBOOST_256 |

## Member Function Documentation

## § create()

static Ptr<BoostDesc> cv::xfeatures2d::BoostDesc::create | ( | int | desc = `BoostDesc::BINBOOST_256`,
|  | bool | use_scale_orientation = `true`,
|  | float | scale_factor = `6.25f`
| ) |  |
| static

Python:
| retval | = | cv.xfeatures2d.BoostDesc_create( | [, desc[, use_scale_orientation[, scale_factor]]] | )

## § getScaleFactor()

virtual float cv::xfeatures2d::BoostDesc::getScaleFactor | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_BoostDesc.getScaleFactor( |  | )

## § getUseScaleOrientation()

virtual bool cv::xfeatures2d::BoostDesc::getUseScaleOrientation | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_BoostDesc.getUseScaleOrientation( |  | )

## § setScaleFactor()

virtual void cv::xfeatures2d::BoostDesc::setScaleFactor | ( | const float | scale_factor | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_BoostDesc.setScaleFactor( | scale_factor | )

## § setUseScaleOrientation()

virtual void cv::xfeatures2d::BoostDesc::setUseScaleOrientation | ( | const bool | use_scale_orientation | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_BoostDesc.setUseScaleOrientation( | use_scale_orientation | )

The documentation for this class was generated from the following file:

- /build/master-contrib_docs-lin64/opencv_contrib/modules/xfeatures2d/include/opencv2/xfeatures2d.hpp